"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ap = exports.chain = exports.map = exports.warnings = exports.payload = exports.right = exports.fromTaskEither = exports.fromEither = void 0;
const Either = require("fp-ts/lib/Either");
const TaskEither = require("fp-ts/lib/TaskEither");
const function_1 = require("fp-ts/lib/function");
const Warn = require("./Warn");
exports.fromEither = (0, function_1.flow)(Either.map(Warn.of), TaskEither.fromEither);
exports.fromTaskEither = TaskEither.map(Warn.of);
exports.right = (0, function_1.flow)(Warn.of, TaskEither.right);
exports.payload = TaskEither.map((warn) => warn.payload);
exports.warnings = TaskEither.map((warn) => warn.warnings);
exports.map = (0, function_1.flow)(Warn.map, TaskEither.map);
function chain(f) {
    return (ma) => (0, function_1.pipe)(TaskEither.right((p) => (w) => Warn.make(p.payload, p.warnings.concat(w))), TaskEither.ap((0, function_1.pipe)(ma, TaskEither.chain((w) => f(w.payload)))), TaskEither.ap((0, exports.warnings)(ma)));
}
exports.chain = chain;
function ap(fa) {
    return (fab) => (0, function_1.pipe)(TaskEither.right((p) => (w1) => (w2) => Warn.make(p, w1.concat(w2))), TaskEither.ap((0, function_1.pipe)((0, exports.payload)(fab), TaskEither.ap((0, exports.payload)(fa)))), TaskEither.ap((0, exports.warnings)(fa)), TaskEither.ap((0, exports.warnings)(fab)));
}
exports.ap = ap;
