"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.anyOperatorExcept = exports.operator = exports.anyOperator = exports.sepReserveds = exports.reservedWord = exports.expectIdentifier = exports.identifier = exports.quotedIdentifier = exports.quotedInner = exports.quotedEscape = exports.matchIdentifier = exports.symbolKeepWS = exports.symbol = exports._ = void 0;
const typed_parser_1 = require("../typed-parser");
const constants_1 = require("../constants");
// Token parsers
// whitespace and comments
exports._ = (0, typed_parser_1.seqNull)((0, typed_parser_1.skip)('\\s*'), (0, typed_parser_1.many)((0, typed_parser_1.oneOf)((0, typed_parser_1.seqNull)((0, typed_parser_1.expectString)('--'), (0, typed_parser_1.stringBeforeEndOr)('\n'), (0, typed_parser_1.skip)('\\s*')), (0, typed_parser_1.seqNull)((0, typed_parser_1.expectString)('/*'), (0, typed_parser_1.stringUntil)('\\*/'), (0, typed_parser_1.skip)('\\s*')))));
function symbol(s) {
    return (0, typed_parser_1.seqNull)((0, typed_parser_1.expectString)(s, 'symbol'), exports._);
}
exports.symbol = symbol;
// Like symbol but doesn't skip whitespace
function symbolKeepWS(s) {
    return (0, typed_parser_1.expectString)(s, 'symbol');
}
exports.symbolKeepWS = symbolKeepWS;
exports.matchIdentifier = (0, typed_parser_1.match)('[a-zA-Z_][a-zA-Z0-9_]*');
exports.quotedEscape = (0, typed_parser_1.seq2)(symbolKeepWS('\\'), (0, typed_parser_1.oneOf)((0, typed_parser_1.keyword)('"', '"'), (0, typed_parser_1.keyword)('\\', '\\')));
exports.quotedInner = (0, typed_parser_1.seq)((0, typed_parser_1.stringBefore)('[\\"]'), (0, typed_parser_1.oneOf)((0, typed_parser_1.seq)(exports.quotedEscape, (0, typed_parser_1.lazy)(() => exports.quotedInner))((e, t) => e + t), (0, typed_parser_1.constant)('')))((s, tail) => s + tail);
exports.quotedIdentifier = (0, typed_parser_1.seq2)(symbolKeepWS('"'), exports.quotedInner, symbol('"'));
exports.identifier = (0, typed_parser_1.seq1)((0, typed_parser_1.attempt)((0, typed_parser_1.oneOf)((0, typed_parser_1.map)((identifier, toError) => constants_1.sqlReservedWords.includes(identifier.toUpperCase())
    ? toError(`Expected an identifier, got reserved word ${identifier}`)
    : identifier, exports.matchIdentifier), exports.quotedIdentifier)), exports._);
function expectIdentifier(ident) {
    return (0, typed_parser_1.seqConst)(ident, (0, typed_parser_1.attempt)((0, typed_parser_1.map)((match, toError) => match.toLowerCase() !== ident.toLowerCase()
        ? toError(`Expected ${ident}, got ${match}`)
        : ident, exports.matchIdentifier)), exports._);
}
exports.expectIdentifier = expectIdentifier;
const reservedWord = (word) => {
    if (!constants_1.sqlReservedWords.includes(word))
        throw new Error(`INTERNAL ERROR: ${word} is not included in reservedWords`);
    return (0, typed_parser_1.seq1)((0, typed_parser_1.attempt)((0, typed_parser_1.map)((match, toError) => match.toUpperCase() !== word
        ? toError(`Expected ${word}, got ${match}`)
        : word, exports.matchIdentifier)), exports._);
};
exports.reservedWord = reservedWord;
const sepReserveds = (words) => (0, typed_parser_1.attempt)((0, typed_parser_1.seqConst)(words, ...words.split(/\s+/).map((word) => (0, typed_parser_1.seqNull)((0, exports.reservedWord)(word), exports._)), exports._));
exports.sepReserveds = sepReserveds;
exports.anyOperator = (0, typed_parser_1.seq1)((0, typed_parser_1.match)('[-+*/<>=~!@#%^&|`?]{1,63}'), exports._);
const operator = (op) => (0, typed_parser_1.attempt)((0, typed_parser_1.map)((match, toError) => match != op ? toError(`Operator ${op} expected`) : match, exports.anyOperator));
exports.operator = operator;
const anyOperatorExcept = (exclude) => (0, typed_parser_1.attempt)((0, typed_parser_1.map)((match, toError) => exclude.includes(match)
    ? toError(`Operator other than ${exclude.join(' ')} expected`)
    : match, exports.anyOperator));
exports.anyOperatorExcept = anyOperatorExcept;
